;AY emulator on VI53 v0.09
;  TASM - A Table Driven Cross Assembler for the MSDOS* Environment (tasm 3.01  3.2)
;  2008-2010
; "" 1988-1990

TimCtrl		.equ	9Fh
Tim0		.equ	9Ch
Tim1		.equ	9Dh
Tim2		.equ	9Eh

WRTPSG:
L0093:
		push	psw
		push	h
		push	d
		lxi	h, AYmainJmpTable

WRTPSG_dispatch:
		ani	0Fh
		add	a
		call	add_hl_a
		mov	d, m
		inx	h
		mov	h, m
		mov	l, d
		pchl
; End of function WRTPSG

; ---------------------------------------------------------------------------
AYmainJmpTable:	.dw AY00,AY01,AY02,AY03
			.dw AY04,AY05,AY06,AY07
			.dw AY08,AY09,AY10,AY11
			.dw AY12,AY13,AY1415,AY1415
; ---------------------------------------------------------------------------
;	8    A

AY00:
		mov	a, e
		sta	AY_R0
		call	TimerCh0
		jmp	AY1415
; ---------------------------------------------------------------------------
; 4 		 A

AY01:
		mov	a, e
		sta	AY_R1
		call	TimerCh0
		jmp	AY1415
;		  0 

; =============== S U B	R O U T	I N E =======================================


SetFreqTimerCh0:
		lxi	h, AY_R0
		call	FreqAY_to_VI53
		mov	a, l
		out	Tim0
		mov	a, h
		out	Tim0
		ret
; End of function SetFreqTimerCh0

;   AY    53

; =============== S U B	R O U T	I N E =======================================


FreqAY_to_VI53:
		mov	a, m
		inx	h
		mov	h, m
		mov	l, a
		ret
; End of function FreqAY_to_VI53

; ---------------------------------------------------------------------------
;	8    B

AY02:
		mov	a, e
		sta	AY_R2
		call	TimerCh1
		jmp	AY1415
; ---------------------------------------------------------------------------
; 4 		 B

AY03:
		mov	a, e
		sta	AY_R3
		call	TimerCh1
		jmp	AY1415

; =============== S U B	R O U T	I N E =======================================

SetFreqTimerCh1:
		lxi	h, AY_R2
		call	FreqAY_to_VI53
		mov	a, l
		out	Tim1
		mov	a, h
		out	Tim1
		ret

; ---------------------------------------------------------------------------
;	8    C

AY04:
		mov	a, e
		sta	AY_R4
		call	TimerCh2
		jmp	AY1415
; ---------------------------------------------------------------------------
; 4 		 C

AY05:
		mov	a, e
		sta	AY_R5
		call	TimerCh2
		jmp	AY1415
;		  2 

; =============== S U B	R O U T	I N E =======================================

SetFreqTimerCh2:
		lxi	h, AY_R4
		call	FreqAY_to_VI53
		mov	a, l
		out	Tim2
		mov	a, h
		out	Tim2
		ret
; End of function SetFreqTimerCh2

; ---------------------------------------------------------------------------
;	8    

AY11:
		jmp	AY1415
; ---------------------------------------------------------------------------
;  

AY13:
		jmp	AY1415
; ---------------------------------------------------------------------------
; 8    

AY12:
		jmp	AY1415
; ---------------------------------------------------------------------------
;  	

AY06:
		jmp	AY1415
; ---------------------------------------------------------------------------
; 

AY07:
		call	AY07sub
;  /

AY1415:
		pop	d
		pop	h
		pop	psw
subAY07_000:
		ret

; =============== S U B	R O U T	I N E =======================================


AY07sub:
		mov	a, e
		ani	111b
		mov	e, a
		lda	AY_R7_Process
		xra	e		; ,  	
		push	psw
		mov	a,e
		sta	AY_R7_Process
		pop	psw
		lxi	h, AY07JmpTab
		jmp	WRTPSG_dispatch
; ---------------------------------------------------------------------------

; End of function AY07sub

; ---------------------------------------------------------------------------
AY07JmpTab:	.dw subAY07_000,subAY07_001,subAY07_010,subAY07_011
		.dw subAY07_100,subAY07_101,subAY07_110,subAY07_111
;  A

; =============== S U B	R O U T	I N E =======================================


subAY07_001:
; End of function subAY07_001

; =============== S U B	R O U T	I N E =======================================

TimerCh0:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		lxi	h,PrevR7_Flag_Or
		xra	m
		ani	001b
		jz	OnlySetFreq0
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		sta	PrevR7_Flag_Or
		ani	001b
		mvi	a, 36h
		out	TimCtrl
		jz	SetFreqTimerCh0
		ret
OnlySetFreq0:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		ani	001b
		jz	SetFreqTimerCh0
		ret
; End of function TimerCh0


; =============== S U B	R O U T	I N E =======================================
;  B
subAY07_010:

; =============== S U B	R O U T	I N E =======================================
TimerCh1:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		lxi	h,PrevR7_Flag_Or
		xra	m
		ani	010b
		jz	OnlySetFreq1
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		sta	PrevR7_Flag_Or
		ani	010b
		mvi	a, 76h
		out	TimCtrl
		jz	SetFreqTimerCh1
		ret
OnlySetFreq1:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		ani	010b
		jz	SetFreqTimerCh1
		ret
; End of function TimerCh1

; ---------------------------------------------------------------------------
;  C
subAY07_100:

; =============== S U B	R O U T	I N E =======================================

TimerCh2:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		lxi	h,PrevR7_Flag_Or
		xra	m
		ani	100b
		jz	OnlySetFreq2
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		sta	PrevR7_Flag_Or
		ani	100b
		mvi	a, 0B6h
		out	TimCtrl
		jz	SetFreqTimerCh2
		ret
OnlySetFreq2:
		lda	AY_R7_Process
		lxi	h,VolFlags
		ora	m
		ani	100b
		jz	SetFreqTimerCh2
; End of function TimerCh2

; ---------------------------------------------------------------------------

subAY07_011:
		call	subAY07_001
		jmp	subAY07_010
; ---------------------------------------------------------------------------

subAY07_101:
		call	subAY07_001
		jmp	subAY07_100
; ---------------------------------------------------------------------------

subAY07_110:
		call	subAY07_010
		jmp	subAY07_100
; ---------------------------------------------------------------------------

subAY07_111:
		call	subAY07_001
		jmp	subAY07_110
; ---------------------------------------------------------------------------
;  A
AY08:
		mov	a, e
		ani	10000b		;   
		jnz	AY1415
		mov	a, e
		ani	1111b		;  
		cpi	3
		jc	Ch0off		;  <3 (0-2)   
					;   
;"" 
		lxi	h,VolFlags
		mov	a,m
		ani	110b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh0
		jmp	AY1415
; 
Ch0off:
		lxi	h,VolFlags
		mov	a,m
		ori	001b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh0
		jmp	AY1415
; ---------------------------------------------------------------------------

;  B
AY09:
		mov	a, e
		ani	10000b		;   
		jnz	AY1415
		mov	a, e
		ani	1111b		;  
		cpi	3
		jc	Ch1off		;  <3 (0-2)   
					;   
;"" 
		lxi	h,VolFlags
		mov	a,m
		ani	101b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh1
		jmp	AY1415
; 
Ch1off:
		lxi	h,VolFlags
		mov	a,m
		ori	010b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh1
		jmp	AY1415
; ---------------------------------------------------------------------------
;  C
AY10:
		mov	a, e
		ani	10000b		;   
		jnz	AY1415
		mov	a, e
		ani	1111b		;  
		cpi	3
		jc	Ch2off		;  <3 (0-2)   
					;   
;"" 
		lxi	h,VolFlags
		mov	a,m
		ani	011b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh2
		jmp	AY1415
; 
Ch2off:
		lxi	h,VolFlags
		mov	a,m
		ori	100b
		cmp	m
		jz	AY1415
		mov	m,a
		call	TimerCh2
		jmp	AY1415
; ---------------------------------------------------------------------------
AY_R0:		.db 1
AY_R1:		.db 1
AY_R2:		.db 1
AY_R3:		.db 1
AY_R4:		.db 1
AY_R5:		.db 1
AY_R7_Process:	.db 111b
VolFlags	.db 111b
PrevR7_Flag_Or	.db 111b

; =============== S U B	R O U T	I N E =======================================

add_hl_a:
		add	l
		mov	l, a
		rnc
		inr	h
		ret
; End of function add_hl_a


		.end
